From patchwork Mon Nov 14 12:49:13 2022
Content-Type: text/plain; charset="utf-8"
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
X-Patchwork-Submitter: Jason Yan <yanaijie@huawei.com>
X-Patchwork-Id: 183141
Return-Path: <yanaijie@huawei.com>
Received: from dggems705-chm.china.huawei.com (10.3.19.182) by
 dggems702-chm.china.huawei.com (10.3.19.179) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31 via Mailbox Transport; Mon, 14 Nov 2022 20:32:32 +0800
Received: from canpemm500004.china.huawei.com (7.192.104.92) by
 dggems705-chm.china.huawei.com (10.3.19.182) with Microsoft SMTP Server
 (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id
 15.1.2375.31; Mon, 14 Nov 2022 20:32:32 +0800
Received: from huawei.com (10.175.127.227) by canpemm500004.china.huawei.com
 (7.192.104.92) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256) id 15.1.2375.31; Mon, 14 Nov
 2022 20:32:31 +0800
From: Jason Yan <yanaijie@huawei.com>
To: <yanaijie@huawei.com>, <zhengzengkai@huawei.com>, <xiexiuqi@huawei.com>,
	<yi.zhang@huawei.com>, <patchwork@huawei.com>, <kernel.openeuler@huawei.com>,
	<houtao1@huawei.com>
Subject: [PATCH OLK-5.10 v2 044/308] cifsd: Remove smb2_put_name()
Date: Mon, 14 Nov 2022 20:49:13 +0800
Message-ID: <20221114125337.1831594-45-yanaijie@huawei.com>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20221114125337.1831594-1-yanaijie@huawei.com>
References: <20221114125337.1831594-1-yanaijie@huawei.com>
Content-Type: text/plain
X-MS-Exchange-Organization-Network-Message-Id: 
 60945999-a68b-4633-fad9-08dac63c4d2d
X-MS-Exchange-Organization-AuthSource: canpemm500004.china.huawei.com
X-MS-Exchange-Organization-AuthAs: Internal
X-MS-Exchange-Organization-AuthMechanism: 07
X-Originating-IP: [10.175.127.227]
X-ClientProxiedBy: dggems702-chm.china.huawei.com (10.3.19.179) To
 canpemm500004.china.huawei.com (7.192.104.92)
X-MS-Exchange-Transport-EndToEndLatency: 00:00:00.6929266
X-MS-Exchange-Processed-By-BccFoldering: 15.01.2375.031
MIME-Version: 1.0

From: Marios Makassikis <mmakassikis@freebox.fr>

mainline inclusion
from mainline-5.15-rc1
commit 915f570a971b4e5abd95e8b169dd41c120ab5a5b
category: feature
bugzilla: https://gitee.com/openeuler/kernel/issues/I60T7G
CVE: NA

Reference: https://git.kernel.org/torvalds/linux/c/915f570a971b

-------------------------------

smb2_put_name() is called twice, and both call sites do the IS_ERR() check
before.

Signed-off-by: Marios Makassikis <mmakassikis@freebox.fr>
Signed-off-by: Namjae Jeon <namjae.jeon@samsung.com>
Signed-off-by: Steve French <stfrench@microsoft.com>
Signed-off-by: Jason Yan <yanaijie@huawei.com>
---
 fs/cifsd/smb2pdu.c | 14 ++------------
 1 file changed, 2 insertions(+), 12 deletions(-)

diff --git a/fs/cifsd/smb2pdu.c b/fs/cifsd/smb2pdu.c
index 08b06ec97e22..1ff0b20ff7b8 100644
--- a/fs/cifsd/smb2pdu.c
+++ b/fs/cifsd/smb2pdu.c
@@ -666,16 +666,6 @@ smb2_get_name(struct ksmbd_share_config *share, const char *src,
 	return unixname;
 }
 
-/**
- * smb2_put_name() - free memory allocated for filename
- * @name:	filename pointer to be freed
- */
-static void smb2_put_name(void *name)
-{
-	if (!IS_ERR(name))
-		kfree(name);
-}
-
 int setup_async_work(struct ksmbd_work *work, void (*fn)(void **), void **arg)
 {
 	struct smb2_hdr *rsp_hdr;
@@ -5418,7 +5408,7 @@ static int smb2_rename(struct ksmbd_work *work, struct ksmbd_file *fp,
 out:
 	kfree(pathname);
 	if (!IS_ERR(new_name))
-		smb2_put_name(new_name);
+		kfree(new_name);
 	return rc;
 }
 
@@ -5483,7 +5473,7 @@ static int smb2_create_link(struct ksmbd_work *work,
 		rc = -EINVAL;
 out:
 	if (!IS_ERR(link_name))
-		smb2_put_name(link_name);
+		kfree(link_name);
 	kfree(pathname);
 	return rc;
 }

